/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2023.02.01
;  *       @˾/            : SINOMCU.COM-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢ Ȩ.
;  *----------------------ժҪ---------------------------------
;  *    MC51F7424 Ӳ˳ʹʾ.
;  *LED2ת1S,printfضUART1.reame.txt.
******************************************************************************/

#include "User_Def.h"

#define REV_STR "2023-02-02"
uint8_t code HW_buff[]="\r\n\r\n***** MC51F7424 MUL DIV *****\r\n*****rev:"REV_STR" "__TIME__; 

#define LED_BLINK_HALF_PRE        50   /*uint 10ms*/

void main(void)
{
  uint8_t xdata LED_count;
  uint32_t mul_result =0,div_result =0,cacl_divvarA =DIV_VAR_A;
  uint16_t cacl_mulvarA  =MUL_VAR_A,cacl_varB =MUL_DIV_VAR_B;

  DISABLE_GIE();   /*رж*/
#if( FSYS_CLOCK ==24000000UL)
  Set_FHS_ClkDiv(FHS_DIV_1); // SYS_CORE_CLK 24MHz
#endif
  GPIO_Init();
  TIM0_Init(TIM_TICK_1MS);
  UART1_Init(BAUD_RATE);
  ENABLE_GIE();    /*ж*/
  
  printf(HW_buff);  
  printf("\r\n--Inf:System clock %luHz.",FSYS_CLOCK); 
  
  Start_10MS_SF_Timer();
#if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV )
  printf("\r\n--Inf:MCU MUL DIV.");
#else
  printf("\r\n--Inf:Lib MUL DIV.");
#endif 
  while (1) {
    if(Get_State_10MS_SF_Timer() == SF_TIMER_OV) {
      Start_10MS_SF_Timer();
      
      LED_count++;
      if( LED_count ==LED_BLINK_HALF_PRE) {
        LED1_ON();
        mul_result=Cacl_16mul16(cacl_mulvarA,cacl_varB);
        LED1_OFF(); 

        LED1_ON();
        div_result = Cacl_32div16(cacl_divvarA,cacl_varB);
        LED1_OFF();

        #if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV)
        LED1_ON();          
        g_divA =DIV_VAR_A;
        g_divB =MUL_DIV_VAR_B;
        LED1_ON();
        Cacl_32div16_gvar();
        LED1_OFF(); 
        #endif 

        printf("\r\n--Inf: %u * %u =%lu.",cacl_mulvarA,cacl_varB,mul_result);
        printf("\r\n--Inf: %lu / %u =%lu,Remadinder %u",cacl_divvarA,cacl_varB,div_result,g_div_remainder);

        #if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV)  
        printf("\r\n--Inf: %lu / %u =%lu,Remadinder %u",g_divA,g_divB,g_div_result,g_div_remainder);
        #endif 

        LED_count =0;
        LED2_TOGGLE();
      }
    }
  }
}

/**************************** end of file *********************************************/
